%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object           Location in Problem Statement                                                                              Class
%matrix_10000_1_benchmark    bench       matrix_10000_1       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_1_data         data        matrix_10000_1       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_1_vars         vars        matrix_10000_1       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    cell
%matrix_10000_2_benchmark    bench       matrix_10000_2       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_2_data         data        matrix_10000_2       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_2_vars         vars        matrix_10000_2       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    cell
%matrix_10000_3_benchmark    bench       matrix_10000_3       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_3_data         data        matrix_10000_3       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_3_vars         vars        matrix_10000_3       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    cell
%matrix_10000_4_benchmark    bench       matrix_10000_4       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_4_data         data        matrix_10000_4       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_4_vars         vars        matrix_10000_4       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    cell
%matrix_10000_5_benchmark    bench       matrix_10000_5       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_5_data         data        matrix_10000_5       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%matrix_10000_5_vars         vars        matrix_10000_5       prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    cell
%matrix_sum_of_x_5_data      data        matrix_sum_of_x_5    linear(matrix_sum_of_x_5)                                                                                  double
%matrix_sum_of_x_5_vars      vars        matrix_sum_of_x_5    linear(matrix_sum_of_x_5)                                                                                  cell
%parameter_bound_data        data        parameter_bound      Constraint: <= parameter_bound                                                                             double
%parameter_alpha_data        data        parameter_alpha      prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)    double
%parameter_bound_1_data      data        parameter_bound_1    Box: >= parameter_bound_1, <= parameter_bound_2                                                            double
%parameter_bound_2_data      data        parameter_bound_2    Box: >= parameter_bound_1, <= parameter_bound_2                                                            double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_10000_1_benchmark,matrix_10000_1_data,matrix_10000_1_vars,matrix_10000_2_benchmark,matrix_10000_2_data,matrix_10000_2_vars,matrix_10000_3_benchmark,matrix_10000_3_data,matrix_10000_3_vars,matrix_10000_4_benchmark,matrix_10000_4_data,matrix_10000_4_vars,matrix_10000_5_benchmark,matrix_10000_5_data,matrix_10000_5_vars,matrix_sum_of_x_5_data,matrix_sum_of_x_5_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_bound_2_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_10000_1',matrix_10000_1_data,matrix_10000_1_vars,matrix_10000_1_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_10000_2',matrix_10000_2_data,matrix_10000_2_vars,matrix_10000_2_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_10000_3',matrix_10000_3_data,matrix_10000_3_vars,matrix_10000_3_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_10000_4',matrix_10000_4_data,matrix_10000_4_vars,matrix_10000_4_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_10000_5',matrix_10000_5_data,matrix_10000_5_vars,matrix_10000_5_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_sum_of_x_5',matrix_sum_of_x_5_data,matrix_sum_of_x_5_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  linear(matrix_sum_of_x_5)',...
'Constraint: <= parameter_bound',...
'  prmulti_pen(parameter_alpha,matrix_10000_1,matrix_10000_2,matrix_10000_3,matrix_10000_4,matrix_10000_5)',...
'Box: >= parameter_bound_1, <= parameter_bound_2',...
'',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

